var produtoValidations = function (ScreenService, templateManager, ValidationEngine, MessageService) {

    var validSemiLevel = function(value, use) {
        
        /* MSG NOVA */
		var variaveis = {
            LEVELMASKPROD: getLevelMaksPenul()
        };
		
		/* FIM MSG NOVA */  
        
        return {
            "valid": validLevel(value, use),
            "message": MessageService.showMessageByCode("GETLEVELMASKPROD", variaveis, {"type":"error"})
        };
        // "message": ScreenService.i18n('Nível do produto deve ser igual a '+getLevelMaksPenul())
    };

    var validNivante = function(value, params) {
        return {
            "valid": validRealNivante(value, params.widgetName, params.nivanteValue),
            "message": ScreenService.i18n(params.message || 'Código inválido para produto pai selecionado.')
        };
    };

    ValidationEngine.registerValidation('containsNivante', validNivante);
    ValidationEngine.registerValidation('penultimateLevel', validSemiLevel);

    function validLevel(value, use) {
        var rightValue = getLevelMaksPenul();
        if (value != rightValue && use) {
            return false;
        } else {
            return true;
        }
    }

    function validRealNivante(value, widgetName, cdnivanteName) {
        var widget = templateManager.container.getWidget(widgetName);
        var cdnivante = widget.currentRow[cdnivanteName] || null;
        var valueDesmasked = value.split('.').join('');

        if (cdnivante && cdnivante !== valueDesmasked.substr(0, cdnivante.length)) {
            return false;
        } else {
            return true;
        }
    }

    function getLevelMaksPenul() {
        var mask = getMaskPenulLevel();
        mask = mask.split('.');
        return mask.length;
    }
    

    function getMaskPenulLevel() {
        var mask = getLocalVar('GER_CDPICTPROD');
		mask = mask.split('.');
		mask.pop();
		return mask.join('.');
    }



};

Configuration(function (ContextRegister, eventEngine) {
    ContextRegister.register('produtoValidations', produtoValidations);
});